plugins['auth'] = (function() {
    return {

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~auth" + "|" + hash + "\" />";
            sendcommand();
        },

        setLang: function() {
            // This method is used to apply a language strings to html elements
            $('#auth_element').attr('title',lang.authstring);
        },

        preAuth: function(target,source) {
            // Attempt to authenticate using browser session

            if(getExten != '' && getPass != '') {
                debug('skip plugin preauth as we are passed exten/pass in url');
                return;
            }

            var a = "sid";
            b = document.cookie.match('(^|;)\\s*' + a + '\\s*=\\s*([^;]+)');
            if (b && b !== "null" && b !== "undefined") {
                b = b.pop();
                queuedcommand = "<msg data=\"0|preauth|" + btoa(b) + "|\" />";
                sendcommand();
            } else {
                // No cookie found, increment preauth variable to use standard exten/pass form
                preauth++;
                showSecBox();
            }
        },

        postAuth: function(context,extension,secret) {
             // Attempt to authenticate with extension/password from auth form
            b = context+'~'+extension+'~'+secret;
            queuedcommand = "<msg data=\"0|postauth|" + btoa(b) + "|\" />";
            sendcommand();
        },

        callback_doauth: function(uno,datos) {
             // Send actual auth command to server
             var parts  = datos.split('~');
             var user   = parts[0];
             var pass   = parts[1];
             var hash   = hex_md5(pass+lastkey);

             myextension = user;
             secret      = pass;

             queuedcommand = "<msg data=\"1|auth|" + user + "|" + hash + "\" />";
             sendcommand();
             init();
        },

        init: function() {
            debug('auth plugin init');
        }
    }
}());
