<?php

// Die if we are called via web, we only want to be run from command line
if (php_sapi_name() !='cli') exit;

$sDEBUG=0;
if (isset($argv[1])) {
   $sDEBUG=1;
} 

require_once("config.php");
require_once("functions.php");
require_once("system.php");
require_once("dblib.php");
require_once("asmanager.php");
require_once("dbconn.php");
require_once("secure/secure-functions.php");
require_once("dbsetup.php");

if(!$res = $astman->connect($conf["MGRHOST"].":".$conf["MGRPORT"], $conf["MGRUSER"] , $conf["MGRPASS"], 'off')) {
    unset($astman);     
}                       

// This script will update all the fop2 tables with information about the system
// This is needed to be run whenever there is a change in the PBX configuration
// or when asterisk is reloaded. So, the same fop2 could run this script on
// RELOAD!!

$panelcontexts = fop2_populate_contexts();

foreach($panelcontexts as $panelcontext=>$contextname) {

    if($sDEBUG==1) { echo "Updating buttons for context $contextname\n"; }

    $system_buttons = system_all_buttons();

    if ($sytem_buttons === false) {
		return; // Something borked, pls fix me
	}

    $fop2_buttons   = fop2_all_buttons();

    if(!isset($fop2_buttons))   { $fop2_buttons = array(); }
    if(!isset($system_buttons)) { $system_buttons = array(); }

    $system_buttons_context = array();
    foreach($system_buttons as $key=>$arradata) {
        if($arradata['context_id']==$panelcontext) {
            $system_buttons_context[$key]=1;
        }
    }

    $del_buttons = array_diff(array_keys($fop2_buttons),array_keys($system_buttons_context));
    $add_buttons = array_diff(array_keys($system_buttons_context),array_keys($fop2_buttons));

	$fop2_button_keys = array_keys($fop2_buttons);
	foreach($system_buttons as $device => $settings) {
		if(in_array($device, $fop2_button_keys)) {
			if($settings['name'] != $fop2_buttons[$device]['name']) {
					$add_buttons[] = $device;
					continue;
			}
			if($settings['type'] == 'extension') {
				if ($settings['exten'] != $fop2_buttons[$device]['exten'] ||
						$settings['context'] != $fop2_buttons[$device]['context']
				) {
						$add_buttons[] = $device;
				}
			}
		}
	}

    if(!isset($del_buttons)) { $del_buttons = array(); }
    if(!isset($add_buttons)) { $add_buttons = array(); }

    // Remove buttons that are not in the system anymore
    foreach($del_buttons as $chan) {
        $result = $db->select('id,exten','fop2buttons','',"device='$chan'");
        $id     = $result[0]['id'];
        $exten  = $result[0]['exten'];

        if($sDEBUG==1) { echo "Removing button $chan\n"; }

        fop2_del_button($id,$exten);
    }

    foreach($add_buttons as $chan=>$dat) {

        $det = $system_buttons[$dat];
        $queuechannel   = (isset($det['queuechannel']))?$det['queuechannel']:'';
        $customastdb    = (isset($det['customastdb']))?$det['customastdb']:'';
        $mailbox        = (isset($det['mailbox']))?$det['mailbox']:'';
        $email          = (isset($det['email']))?$det['email']:'';
        $group          = (isset($det['group']))?$det['group']:'';
        $external       = (isset($det['external']))?$det['external']:'';
        $queuecontext   = (isset($det['queuecontext']))?$det['queuecontext']:'';
        $extenvoicemail = (isset($det['extenvoicemail']))?$det['extenvoicemail']:'';
        $context_id     = (isset($det['context_id']))?$det['context_id']:'';
        $originatechannel     = (isset($det['originatechannel']))?$det['originatechannel']:'';
        $extrachan= (isset($det['extrachannel']))?$det['extrachannel']:'';

        if($sDEBUG==1) { echo "Adding button ".$det['channel']." into context $contextname\n"; }

        $results = $db->consulta(
				"insert INTO fop2buttons (type, device, label, exten, context, mailbox, queuechannel, customastdb, email, `group`, external, queuecontext, extenvoicemail, originatechannel, context_id, channel) ".
				"VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s','%s','%s', '%s') ".
				"on duplicate key update
					type = values(type),
					device = values(device),
					label = values(label),
					exten = values(exten),
					context = values(context),
					mailbox = values(mailbox),
					queuechannel = values(queuechannel),
					customastdb = values(customastdb),
					email = values(email),
					`group` = values(`group`),
					external = values(external),
					queuecontext = values(queuecontext),
					extenvoicemail = values(extenvoicemail),
					originatechannel = values(originatechannel),
					context_id = values(context_id),
					channel = values(channel)",
				array($det['type'],$det['channel'],$det['name'],$det['exten'],$det['context'],$mailbox,$queuechannel,$customastdb,$email,	$group,$external,$queuecontext,$extenvoicemail,$originatechannel,$context_id,$extrachan)
		);
    }

    $fop2_buttons   = fop2_all_buttons();

    if(isset($argv[2])) {

        if($sDEBUG==1) { echo "Inserting users for context $contextname\n"; }

        fop2_insert_users();
    }

    if($panelcontext==0) {
        $wherepanelcontext = '';
    } else {
        $wherepanelcontext = " AND context_id='$panelcontext' ";
    }

    fop2_recreate_default_groups($predefined_groups,$panelcontext,$wherepanelcontext,$fop2_buttons);

    if($config_engine=='freepbx' || $config_engine=='mirtapbx') {
        // If we are on FreePBX, then update queuechannel and mailbox automagically
        foreach($system_buttons as $chan=>$dat) {
            if($dat['type']=='extension') {

                if(isset($fop2_buttons[$chan]['queuechannel']) && isset($dat['queuechannel'])) {
                    $fop2qchan = $fop2_buttons[$chan]['queuechannel'];
                    if($fop2qchan <> $dat['queuechannel']) {
                        $query = "UPDATE fop2buttons SET queuechannel='%s' WHERE device='%s'";
                        $db->consulta($query,array($dat['queuechannel'],$chan));
                        $need_update=1;
                    }
                }

                if(isset($fop2_buttons[$chan]['mailbox']) && isset($dat['mailbox'])) {
                    $fop2mbox  = $fop2_buttons[$chan]['mailbox'];
                    if($fop2mbox <> $dat['mailbox']) {
                        $query = "UPDATE fop2buttons SET mailbox='%s' WHERE device='%s'";
                        $db->consulta($query,array($dat['mailbox'],$chan));
                        $need_update=1;
                    }
                }

                if(isset($fop2_buttons[$chan]['queuecontext']) && isset($dat['queuecontext'])) {
                    $fop2qctx  = $fop2_buttons[$chan]['queuecontext'];
                    if($fop2qctx <> $dat['queuecontext']) {
                        $query = "UPDATE fop2buttons SET queuecontext='%s' WHERE device='%s'";
                        $db->consulta($query,array($dat['queuecontext'],$chan));
                        $need_update=1;
                    }
                }

                if(isset($fop2_buttons[$chan]['extenvoicemail']) && isset($dat['extenvoicemail'])) {
                    $fop2extv  = $fop2_buttons[$chan]['extenvoicemail'];
                    if($fop2extv <> $dat['extenvoicemail']) {
                        $query = "UPDATE fop2buttons SET extenvoicemail='%s' WHERE device='%s'";
                        $db->consulta($query,array($dat['extenvoicemail'],$chan));
                        $need_update=1;
                    }
                }

                if(isset($fop2_buttons[$chan]['accountcode']) && isset($dat['accountcode'])) {
                    $fop2extv  = $fop2_buttons[$chan]['accountcode'];
                    if($dat['accountcode']<>'') {
                        $query = "UPDATE fop2buttons SET accountcode='%s' WHERE device='%s'";
                        $db->consulta($query,array($dat['accountcode'],$chan));
                        $need_update=1;
                    }
                }

                if(isset($fop2_buttons[$chan]['email']) && isset($dat['email'])) {
                    $fop2extv  = $fop2_buttons[$chan]['email'];
                    if($dat['email']<>'') {
                        $query = "UPDATE fop2buttons SET email='%s' WHERE device='%s'";
                        $db->consulta($query,array($dat['email'],$chan));
                        $need_update=1;
                    }
                }

                // Sync names for extensions
                if(isset($fop2_buttons[$chan]['name']) && isset($dat['name'])) {
                    $fop2name  = $fop2_buttons[$chan]['name'];
                    if($dat['name']<>$fop2name) {
                        $query = "UPDATE fop2buttons SET label='%s' WHERE device='%s'";
                        $db->consulta($query,array($dat['name'],$chan));
                        if($astman) {
                            $res = $astman->UserEvent('FOP2CHANGEBUTTONLABEL',array('FOP2Channel'=>$chan,'Label'=>$dat['name'],'Context'=>$panelcontext));
                        }
                    }
                }

            }
        }
    }
}

plugin_insert_missing_db();

// Execute php update script for plugins if they exists
$dir = dirname(__FILE__);
$pepe = get_installed_plugins();
foreach($pepe as $plugname=>$val) {
    $updatescript = $dir."/plugins/$plugname/update_conf.php";
    if(is_file($updatescript)) {
        system("php -f $updatescript");
    }
}
if($astman) {
    $res = $astman->UserEvent('FOP2RELOAD',array('Do'=>'FOP2RELOAD','Channel'=>'ZAP/1'));
}
